"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.init = void 0;
const express_1 = __importDefault(require("express"));
const ServerHandler_1 = require("./ServerHandler");
const init = () => {
    const router = express_1.default.Router();
    const expressApp = (0, express_1.default)();
    const spy = new ServerHandler_1.ServerHandler();
    expressApp.use(express_1.default.json());
    router.post('/values', spy.onPostHandler.bind(spy));
    expressApp.use('/', router);
    expressApp.use(function (req, res) {
        res.setHeader('Content-Type', 'text/plain');
        res.write('you posted:\n');
        res.end(JSON.stringify(req.body, null, 2));
    });
    expressApp.listen(4444, () => {
        console.log('Started on PORT 4444');
    });
    return spy;
};
exports.init = init;
//# sourceMappingURL=server.js.map